import { ConstantLocalStorage } from '@/utils/constant'
import { ConstantStore } from '@/utils/constant'
import { defineStore } from 'pinia'
import { useLocalStorageState } from 'vue-hooks-plus'


export const useOpraRecordStore = defineStore(ConstantStore.OPRARECORDS, () => {

  const [ state, setState ] = useLocalStorageState<API.LearnPlanRecords[]>(ConstantLocalStorage.OPRARECORDS, {
    defaultValue: []
  })

  const _push = (records: any) => setState([...state.value!, records])

  const _clear = () => setState([])

  const _get = () => state.value

  const _correctQuantityTotal = state.value?.map( item => item.correctQuantity).reduce( (pre, next) => pre + next )

  const _totalQuantity =  state.value?.map( item => item.totalQuantity).reduce( (pre, next) => pre + next )
 
  return {
    push: _push,
    get: _get,
    clear: _clear,
    totalCorrectQuantity: _correctQuantityTotal,
    totalQuantity: _totalQuantity,
    length: state.value?.length
  }

})